#ifndef UNIVERSO_H
#define UNIVERSO_H

#include <vector>

#include "Corpo.h"

using namespace std;

class Universo {
  public:
  
    inline void add_corpo(const Corpo &c) { corpi.push_back(c); }
    inline int get_n_corpi() const { return corpi.size(); }
    
    // imposta i limiti
    void set_limits(double mx, double my, double MX, double MY); 
    
    // esegue i calcoli per il movimento degli oggetti
    void animate();
    
  //private:
    
    // i "limiti" dell'universo
    double minx, miny, maxx, maxy;
    
    // la lista dei corpi
    vector<Corpo> corpi;
    
    // calcola le nuove posizioni
    void move_stuff();
    
    // controlla le collisioni
    void check_collisions();

};

#endif