#ifndef _CRYPTOGRAM_H
#define _CRYPTOGRAM_H

#include <stdlib.h>
#include <iostream>
#include <string>
#include <vector>

class Cryptogram {
 public:
  Cryptogram();
  Cryptogram(const std::string& s);
  
  int operator [] (int i) const;
  friend std::ostream& operator << (std::ostream& os, const Cryptogram& c);
  
  int length() const;
  void load_text(const std::string& s);
  std::vector<Cryptogram> extract_words() const;
 private:
  std::vector<int> list;
};

#endif
