#ifndef _CRYPTOSOLVER_H
#define _CRYPTOSOLVER_H

#include <string>
#include "dict.h"
#include "cryptogram.h"

class CryptoSolver {
 public:
  
  void load_dict(const Dict& d);
  void load_dict(const std::string& s);
  
  void solve(const Cryptogram& cg);
  
 private:
  Dict dic;
  Dict find_matching(const Cryptogram &w) const;
  static bool word_match(const std::string& s, const Cryptogram &w);
};

#endif
