#ifndef LABYDISPLAY_H
#define LABYDISPLAY_H

#include <SDL/SDL.h>
#include "../include/class_virscrsdl.h"

#include "cell.h"
#include "labyrinth.h"

class LabyDisplay {
 public:
  LabyDisplay();
  ~LabyDisplay();
  
  void display(const Labyrinth* laby, const Path *p = NULL) const;
 private:
 
  SDL_Surface *screen;
  VirtualScreenSDL *virscr;
  
  void displaycell(const Cell& cell) const;
  
};



#endif
