/* POINTF.CPP */

#ifndef POINT_H
  #error point.h not included
#endif


/* FUNCTIONS */

POINT_TYPE Point::length() {
  return sqrt( this->x*this->x + this->y*this->y + this->z*this->z );
}

POINT_TYPE Point::length2() {
  return ( this->x*this->x + this->y*this->y + this->z*this->z );
}

Point *crossProduct(Point p1, Point p2, Point *res) {
  res->x = p1.y*p2.z - p1.z*p2.y;
  res->y = p1.z*p2.x - p1.x*p2.z;
  res->z = p1.x*p2.y - p1.y*p2.x;
  return res;
}
