/*  L A B Y     Version 3    */
/* ------------------------- */

/* General infos */
#define VERSION       "3.0"
#define AUTHOR        "Daniele Ferro"
#define AUTHOR_EMAIL  "<ziodf12@tiscali.it>"

/* Error definitions */
#define LABY_ERR_NONE       0
#define LABY_ERR_PARAM      1

/* Includes */
#include <stdlib.h>
#include <stdio.h>

#include "args.h"
#include "labyr.h"

int error(int n) {
  char *err_strings[] = {
    "Nessun errore.",
    "Parametri non validi."
  };
  printf("Errore #%i: %s\n", n, err_strings[n % 2]);
  exit(1);
}



int main(int argc, char *argv[]) {
  parse_args(argc, argv);

  return(0);
}
