#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "master.h"

#define SOLVER_LEN	8

MM_HASHTYPE allhashes = 0, *hashes = NULL;

int main() {
  long long i,j;
  char master[SOLVER_LEN+2], 
       choice[SOLVER_LEN+2], 
       ret[SOLVER_LEN+2];

  MM_SetLength(SOLVER_LEN);
  MM_SetSymbols("123456789");
  
  printf("Scegli una combinazione (%i numeri da 1 a 9, senza spazi): ", SOLVER_LEN);
  fgets(master, 19, stdin);
  master[SOLVER_LEN] = '\0';
  
  srand(time(NULL));
  for (i=0; i<SOLVER_LEN; i++) choice[i] = *(MM_GetSymbols()+rand()%9);
  choice[SOLVER_LEN] = '\0';
  
  MM_HASHTYPE c = ((MM_HASHTYPE)rand()*rand())%MM_CountAll();
  for (;;) {
    MM_ReverseHash(c, choice);
    j = MM_Check(master, choice, ret);
    printf("Provo %s :  %s\n", choice, ret);
    if (j) {
      printf("Vittoria!\n");
      break;
    } else {
      char aa[SOLVER_LEN+2], ret2[SOLVER_LEN+2];
      int oldhash = allhashes;

      if (oldhash == 0) {
        for (i=1; i<=MM_CountAll(); i++) {
          if (i == c) continue;
          MM_ReverseHash(i,aa);
          MM_Check(aa, choice, ret2);
          if (strcmp(ret, ret2) == 0) {
            if ((allhashes&0xFF) == 0)
              hashes = (MM_HASHTYPE*)realloc(hashes, sizeof(MM_HASHTYPE)*(((allhashes>>8)+1)<<8));
            *(hashes+allhashes++) = i;
          }
        }
      } else {
        allhashes = 0;
        for (i=0; i<oldhash; i++) {
          j = *(hashes+i);
          if (j == c) continue;
          MM_ReverseHash(j,aa);
          MM_Check(aa, choice, ret2);
          if (strcmp(ret, ret2) == 0) *(hashes+allhashes++) = j;
        }
      }
    }
    c = *(hashes+((MM_HASHTYPE)rand()*rand())%allhashes);
  }

  free(hashes);
  return(0);
}
