#ifndef _BOLLETTA_H
#define _BOLLETTA_H

class Bolletta {
 public:
  Bolletta();
  Bolletta(const Bolletta& b);
  ~Bolletta();
  bool is_empty() const;
  void add_head(const Telefonata &tel);
  Telefonata del_head();
  void del_call(const Telefonata &tel);
  Telefonata* get_next();
  
  Bolletta& operator=(const Bolletta& b);
 private:
  class Nodo {
   public:
    Nodo();
    Nodo(const Telefonata& t, Nodo *nx);
    Telefonata data;
    Nodo *next;
  };
  Nodo *head, *pointer;
  static Nodo* copy(Nodo *start);
  static void destroy(Nodo *start);
};

ostream& operator<<(ostream& os, Bolletta& b);

#endif
