#ifndef _PERSON_H
#define _PERSON_H

#include <string>

using std::string;
using std::ostream; 

class Person {
 public:
  Person(string nome);
  Person(string nome, int nascita, int morte);
  
  string get_nome() const;
  int get_nascita() const;
  int get_morte() const;
 private:
  string nome;
  int nascita, morte;
};

ostream& operator<< (ostream &os, const Person& p);

#endif
