#ifndef _MONOMIO_H
#define _MONOMIO_H

#include <iostream>
using std::ostream;

class Monomio {
 public:
  Monomio();
  Monomio(int coeff, int esp);

  friend ostream& operator << (ostream& os, const Monomio& m);
  friend bool operator == (const Monomio&, int);
  Monomio operator - ();
  int operator () (int x) const;
  
  bool is_similar(const Monomio&);
  
  int coeff, esp;
 private:
  static int ipow(int x, int e);
};

#endif
