#include <iostream>

using namespace std;

class A {
 public:
  virtual void f() { }
};

class B: virtual public A {
 public:
  virtual void f() { }
};

class C: virtual public A, virtual public B {
 public:
  virtual void f() { }
};

class D: virtual public B, virtual public C, virtual public A {
 public:
  virtual void f() { }
};

A& fun(B& ref) { return ref; }

main() {
  B b;
  B& refb = b;
  C c;
  fun(refb) = c;
  D d;
  B& ref = d;
  
  if(dynamic_cast<B*>(new C()))
    cout << "UNO ";
  else
    cout << "DUE ";
  
  if(!dynamic_cast<C*>(&fun(b)))
    cout << "TRE ";
}

