/* RectPyramid.h */

#ifndef RECTPYRAMID_H
#define RECTPYRAMID_H

#include "Pyramid.h"

/* Una piramide retta (a base convessa) */
class RectPyramid: public Pyramid {
 public:

  // ---- COSTRUTTORI ----
  RectPyramid(int vertbase, const Point3Dd *listvb, double h, std::string n = "Piramide retta");
  
  // ---- OPERATORI ----
  friend std::ostream& operator << (std::ostream &os, const RectPyramid& pr);
  
 protected:
 
  // altezza
  double height;
 
};

#endif
