/*
ID: ziodf121
LANG: C++
TASK: friday
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

int N;
int days[7];

int is_leap(const int year) {
  return ((year%400 == 0)||((year%100 != 0)&&(year%4 == 0)))?1:0;
}

int main() {
  
  FILE *f = fopen("friday.in", "r");
  fscanf(f, "%i", &N);
  fclose(f);
  
  memset(days, 0, sizeof(days));
  
  int lastday = 0; // monday, last day of 1st jan
  int addday[2][12] = {{5,1,1,4,6,2,4,0,3,5,1,3}, {5,1,2,5,0,3,5,1,4,6,2,4}};
  for (int y=1900; y<1900+N; ++y) {
    int l = is_leap(y);
    for (int i=0; i<12; ++i) {
      ++days[(lastday+addday[l][i])%7];
    }
    lastday = (lastday+(l?2:1))%7;
  }
  
  
  
  f = fopen("friday.out", "w");
  fprintf(f, "%i %i %i %i %i %i %i\n", days[5],days[6],days[0],days[1],days[2],days[3],days[4]);
  fclose(f);
  
  return 0;
}