/* CLASS VIRTUALSCREEN */

#ifndef CLASS_VIRSCR_H
#define CLASS_VIRSCR_H

#define VS_ERR_NONE	0

#define VS_DM_NONE	0
#define VS_DM_NORMAL	1
#define VS_DM_ADD	2
#define VS_DM_SUB1	3
#define VS_DM_SUB2	4
#define VS_DM_MUL	5
#define VS_DM_AND	6
#define VS_DM_OR	7
#define VS_DM_XOR	8
#define VS_DM_MIN	9
#define VS_DM_MAX	10
#define VS_DM_BLEND50	11
#define VS_DM_BLEND	VS_DM_BLEND50

class VirtualScreen {
 public:
  int DrawMode;
   
  //VirtualScreen() { DrawMode = VS_DM_NORMAL; };
  //~VirtualScreen();
  
  virtual int GetWidth() {};
  virtual int GetHeight() {};
  
  virtual int PutPixel(int x, int y, int color) {};
  virtual int GetPixel(int x, int y) {};
  
  virtual int Line(int x1, int y1, int x2, int y2, int color);
  virtual int Rect(int x1, int y1, int x2, int y2, int color);
  virtual int Triangle(int x1, int y1, int x2, int y2, int x3, int y3, int color);
  virtual int Circle(int x, int y, int rad, int color);

  virtual int FRect(int x1, int y1, int x2, int y2, int color);
  virtual int FTriangle(int x1, int y1, int x2, int y2, int x3, int y3, int color);
  virtual int FCircle(int x, int y, int rad, int color);
  
  virtual int Show() {};
  virtual int Clear(int color) {};
  
 protected:
  virtual int CatchError(int n, void *data) { };
};

#endif

