/* CLASS_KRYCUBE.H */

#ifndef _CLASS_KRYCUBE_H
#define _CLASS_KRYCUBE_H

#define PLANE_XY_DIR_X		0x00
#define PLANE_XY_DIR_Y		0x01
#define PLANE_XZ_DIR_X		0x02
#define PLANE_XZ_DIR_Z		0x03
#define PLANE_YZ_DIR_Y		0x04
#define PLANE_YZ_DIR_Z		0x05

class Krycube {
 public:
  char flag_dontSkimpMem;
 
  Krycube(int size);
  ~Krycube();
  int Resize(int newsize);
  int Fill(long int length, char *data);
  int Crypt(char *pwd, int magic);
  int Decrypt(char *pwd, int magic);
  int Empty(char *data);
  long int Get_bytestoread() { return(bytestoread); }
 private:
  int size;			// edge of the cube
  long int cubesize;		// size of the cube in bytes
  long int bytestoread;		// bytes that can fit into the cube
  char *cube;			// the Cube!
  int Shift(char plane_dir, int xyz, int amount);
  char Get_cubebit(int x, int y, int z);
  void Set_cubebit(int x, int y, int z, char bit);
  void Get_shiftvalues(char *pwd, int magic, int *values);
};

#endif
