#include "point.h"
#include <math.h>
#include <iostream>

Point::Point(): x(0.0), y(0.0), z(0.0) {
}

Point::Point(double x, double y, double z) {
  this->x = x;
  this->y = y;
  this->z = z;
}

void Point::negate() {
  x = -x;
  y = -y;
  z = -z;
}

double Point::norm() {
  return sqrt(x*x+y*y+z*z);
}

void Point::print() {
  std::cout << x << " " << y << " " << z << std::endl;
}
