#include <iostream>
#include <string>

using namespace std;

class wxWindow {
 public:
  wxWindow(const string& n): name(n) {};
  virtual bool isShown() const { return false; }
  virtual void setSize(int x, int y) { x = x*y; }
  virtual void setTitle(const string& t) { name = t; }
 protected:
  string name;
};

class wxDialog: public wxWindow {
 public:
  bool isModal() const { return false; }
  virtual void setTitle(const string& t) { name = t; }
};

class wxFileDialog: public wxDialog {
 public:
  void setFilename(const string& ) {}
};

class wxTextEntryDialog: public wxDialog {
 public:
  void setValue(const string& ) {}
};

class wxPasswordEntryDialog: public wxTextEntryDialog {
 public:
};

void fun(wxWindow& win) {
  wxPasswordEntryDialog *ped;
  wxFileDialog *fd;
  wxWindow *w;
  ped = dynamic_cast<wxPasswordEntryDialog*>(&win);
  if (ped && ped->isShown()) {
    ped->setValue("password");
    return;
  }
  fd = dynamic_cast<wxFileDialog*>(&win);
  if (fd && fd->isModal()) {
    fd->setTitle("Open File");
    fd->setFilename("df");
    return;
  }
  if (win.isShown()) {
    win.setSize(10,20);
  }
  
}

int main() {
 
  return 0;
}
