/* RectPyramid.cpp */

#include "RectPyramid.h"


// ---- COSTRUTTORI ----------------------------------------------------------

RectPyramid::RectPyramid(int vertbase, const Point3Dd *listvb, double h, std::string n):
 Pyramid(vertbase, listvb, P3Dd_ZERO, n) {
  // Il seguente codice è errato!
  // Invece di usare l'incentro, uso il baricentro, per semplificare
  verts[vertbase] = get_base().get_center() +
    h*((verts[1]-verts[0]).cross(verts[2]-verts[0])).normalize();
  height = h;
}


// ---- OPERATORI ------------------------------------------------------------

// output su ostream
std::ostream& operator << (std::ostream &os, const RectPyramid& pr) {
  os << "RectPyramid \"" << pr.name << "\":\n";
  for (int i=0; i<pr.vertices; i++)
    os << pr.verts[i] << ", ";
  return os << "\n";
}
