#ifndef _TELEFONATA_H
#define _TELEFONATA_H

#include "tempo.h"

class Telefonata {
 public:
  Telefonata();
  Telefonata(const Tempo& start, const Tempo& end, int num); // better string for num

  Tempo get_inizio() const;
  Tempo get_fine() const;
  int get_numero() const;
  Tempo get_durata() const;  
 private:
  Tempo start, end;
  int num;
};

bool operator == (const Telefonata& t1, const Telefonata& t2);
ostream& operator<<(ostream& os, const Telefonata& t);

#endif
