#ifndef _TEMPO_H
#define _TEMPO_H

#include <iostream>

using std::ostream;

class Tempo {
 public:
  Tempo();
  Tempo(int h);
  Tempo(int h, int m);
  Tempo(int h, int m, int s);
  
  int get_ore() const;
  int get_minuti() const;
  int get_secondi() const;
  
  friend Tempo operator +  (const Tempo& t1, const Tempo& t2);
  friend Tempo operator -  (const Tempo& t1, const Tempo& t2);
 private:
  int sec;
};


bool operator  == (const Tempo& t1, const Tempo& t2);
bool operator  <  (const Tempo& t1, const Tempo& t2);
bool operator  <= (const Tempo& t1, const Tempo& t2);
bool operator  >  (const Tempo& t1, const Tempo& t2);
bool operator  >= (const Tempo& t1, const Tempo& t2);

ostream& operator<<(ostream& os, const Tempo& t);

#endif
