#ifndef GUI_H
#define GUI_H

#include "gui_defs.h"
#include "ui_gui.h"

class RapiWindow : public QMainWindow {
  Q_OBJECT

  public:
    
    RapiWindow(QWidget *parent = 0);

  private slots:
    void on_btn_generate_clicked();
    void on_btn_save_clicked();
    void on_btn_exit_clicked();
    void on_check_avanzate_clicked(bool);

  private:
    Ui::RapiWindow ui;
    
    bool generated;
    QString exename;
    QString logname;
    
    void checkExeName();
    
    QTextEdit *ui_text_top;
    QTextEdit *ui_text_result;
    QSpinBox *ui_spin_N;
    QSpinBox *ui_spin_turns;
    QSpinBox *ui_spin_M_G, *ui_spin_M_S, *ui_spin_M_D;
    QSpinBox *ui_spin_P_G, *ui_spin_P_S, *ui_spin_P_D;
    QSpinBox *ui_spin_relax_min, *ui_spin_relax_max;
    QSpinBox *ui_spin_consec;
    QSpinBox *ui_spin_p_consec, *ui_spin_m_consec;
    QSpinBox *ui_spin_pm_week;
    QSpinBox *ui_spin_deep;
    QCheckBox *ui_check_avanzate;
    QGroupBox *ui_group_avanzate;
    
    
};

#endif